var shell = require('shelljs')
var fs = require("fs")
var fsReaddir = require('fs-readdir')
var through2 = require('through2')
var path = require('path')
var hostile = require('hostile')
var chalk = require('chalk')
var minimist = require('minimist')
var net = require('net')
var program = require('commander')

var action = ''
var projectName = ''

if(process.argv.length === 4) {
  action = process.argv[3]
  projectName = process.argv[2]
} else if(process.argv.length === 3) {
  action = process.argv[2]
  projectName = path.resolve(__dirname, '.').replace(`${path.resolve(__dirname, '..')}/`, '')
} else if(process.argv.length !==3 && process.argv.length !== 4){
  console.error('请检查命令格式')
  return
}

var projectPath = `~/project/${projectName}`
var xpmPath = `~/project/xpm/`
var packageJSON = require(`/Users/nali/project/${projectName}/package.json`)
var version = packageJSON.version
var publishFolderPath = `${xpmPath}/grunt/publish`

const model = {
  T: function() {
    console.log('测试命令')
  },
  C: compileCss,
  D: xpmDev,
  L: xpmLocal,
  P: xpmPublish,
  S: http_server_80
}

model[action]()

function test () {
  console.log('test')
}

function xpmDev () {
  shell.cd(projectPath)
  shell.exec(`git add .`)
  shell.exec(`git commit -m "[update] xpm dev ${projectName} ${version} -s"`)
  shell.exec(`git push`)
  shell.exec(`git log`)
  shell.cd(xpmPath)
  shell.exec('git pull')
  shell.cd(projectPath)
  shell.exec(`xpm dev ${projectName} ${version} -s`)
}

function xpmPublish () {
  console.log('开始xpm publish步骤')
  console.log(`项目version: ${version}`)
  
  /* 执行xpm release命令 */
  shell.cd(`${xpmPath}`)
  shell.exec(`git pull`)
  shell.exec(`xpm release ${projectName} ${version} -s`)
  shell.cd(`${publishFolderPath}`)
  shell.exec(`git pull`)
  
  /* 进入publish目录,git pull */
  shell.cd(publishFolderPath)
  shell.exec(`git pull`)
  
  /* 修改publish.json */
  console.log(`读取publish.json`)
  shell.cat(`publish.json`)
  console.log(`开始修改 publish.json`)
  shell.rm('-rf', 'publish.json')
  fs.writeFileSync('publish.json', `{"${projectName}":"${version}"}`,  function(err) {
    if (err) {
        return console.error(err);
    }
    console.log("数据写入成功！");
    console.log("--------我是分割线-------------")
    console.log("读取写入的数据！");
    fs.readFileSync('publish.json', function (err, data) {
       if (err) {
          return console.error(`读publish.json error:${err}`);
       }
       console.log("读取文件数据: " + data.toString());
    });
  });
  console.log(`再次读取publish.json`)
  shell.cat(`publish.json`)
  shell.exec(`date; sleep 10; date`)
  /* 执行 xpm publish 命令 */
  shell.exec(`xpm publish`)
  
  /* git push */
  shell.exec(`git add .`)
  shell.exec(`git commit -m "[update] ${projectName}"`)
  shell.exec(`git push`)
}

function xpmLocal () {
  function xpmSwitchHost () {
    console.log('switch host')
    var ip = '127.0.0.1'
    var host1 = 'static2.pp.ximalaya.com'
    var host2 = 'static2.test.ximalaya.com'
    
    function set (ip, host1, host2) {
      if (!ip || !host1 || !host2) {
        return ('Invalid syntax: hostile set <ip> <host>')
      }
    
      if (ip === 'local' || ip === 'localhost') {
        ip = '127.0.0.1'
      } else if (!net.isIP(ip)) {
        return ('Invalid IP address')
      }
      console.log('abc')
      try {
        hostile.set(ip, host1)
        hostile.set(ip, host2)
        console.log('set')
      } catch (err) {
        console.log('Error: ' + err.message + '. Are you running as root?')
      }
      console.log(chalk.green('Added ' + host1 + host2))
    }
    set(ip, host1, host2)
  }
  xpmSwitchHost()
  console.log('switch host successful')

  shell.cd(xpmPath)
  shell.exec(`pwd`)
  shell.exec(`sudo kill -9 80`)
  shell.exec(`sudo xpm local ${projectName}`)
}

function http_server_80 () {
  // 需要加入 改回正常host
  shell.cd(projectPath)
  shell.exec('pwd')
  shell.exec(`sudo kill -9 80`)
  shell.exec(`sudo http-server -p 80`)
}

function compileCss () {
  console.log('compileCss')
  if(projectName === 'web_static2') {
    console.log('主站CSS编译')
  } 
}

// 生成项目列表,后续生成项目名快捷方式
function traverseProjects () {
  var stream = fsReaddir(xpmPath)
  .on('error', function(err) {
    console.log('error:', err);
  }).on('folder', function(folder) {
    console.log('folder:', folder);
  })
}
// traverseProjects()









