var shell = require('shelljs')
var fs = require("fs")
var fsReaddir = require('fs-readdir')
var through2 = require('through2')
var path = require('path')
var hostile = require('hostile')
var chalk = require('chalk')
var minimist = require('minimist')
var net = require('net')


/* 项目配置 */
// 配置项目名
var projectName = `hybrid-listening-list`
// 配置项目路径
var projectPath = `~/project/${projectName}`
// 配置xpm路径
var xpmPath = `~/project/xpm/`
// 配置项目package.json路径
var packageJSON = require(`/Users/nali/project/${projectName}/package.json`)
// 自动获取项目版本号，获取自package.json
var version = packageJSON.version
// 自动获取xpm/grunt/publish目录
var publishFolderPath = `${xpmPath}/grunt/publish`

function xpmDev () {
  shell.cd(projectPath)
  shell.exec(`git add .`)
  shell.exec(`git commit -m "[update] xpm dev ${projectName} ${version} -s"`)
  shell.exec(`git push`)
  shell.exec(`git log`)
  shell.cd(xpmPath)
  shell.exec('git pull')
  shell.cd(projectPath)
  shell.exec(`xpm dev ${projectName} ${version} -s`)
}

function xpmPublish () {
  console.log('开始xpm publish步骤')
  console.log(`项目version: ${version}`)
  
  /* 执行xpm release命令 */
  shell.cd(`${xpmPath}`)
  shell.exec(`git pull`)
  shell.exec(`xpm release ${projectName} ${version} -s`)
  shell.cd(`${publishFolderPath}`)
  shell.exec(`git pull`)
  
  /* 进入publish目录,git pull */
  shell.cd(publishFolderPath)
  shell.exec(`git pull`)
  
  /* 修改publish.json */
  console.log(`读取publish.json`)
  shell.cat(`publish.json`)
  console.log(`开始修改 publish.json`)
  shell.rm('-rf', 'publish.json')
  fs.writeFileSync('publish.json', `{"${projectName}":"${version}"}`,  function(err) {
    if (err) {
        return console.error(err);
    }
    console.log("数据写入成功！");
    console.log("--------我是分割线-------------")
    console.log("读取写入的数据！");
    fs.readFileSync('publish.json', function (err, data) {
       if (err) {
          return console.error(`读publish.json error:${err}`);
       }
       console.log("读取文件数据: " + data.toString());
    });
  });
  console.log(`再次读取publish.json`)
  shell.cat(`publish.json`)
  shell.exec(`date; sleep 10; date`)
  /* 执行 xpm publish 命令 */
  shell.exec(`xpm publish`)
  
  /* git push */
  shell.exec(`git add .`)
  shell.exec(`git commit -m "[update] ${projectName}"`)
  shell.exec(`git push`)
}

function xpmLocal () {
  function xpmSwitchHost () {
    console.log('switch host')
    var ip = '127.0.0.1'
    var host1 = 'static2.pp.ximalaya.com'
    var host2 = 'static2.test.ximalaya.com'
    
    function set (ip, host1, host2) {
      if (!ip || !host1 || !host2) {
        return ('Invalid syntax: hostile set <ip> <host>')
      }
    
      if (ip === 'local' || ip === 'localhost') {
        ip = '127.0.0.1'
      } else if (!net.isIP(ip)) {
        return ('Invalid IP address')
      }
      console.log('abc')
      try {
        hostile.set(ip, host1)
        hostile.set(ip, host2)
        console.log('set')
      } catch (err) {
        console.log('Error: ' + err.message + '. Are you running as root?')
      }
      console.log(chalk.green('Added ' + host1 + host2))
    }
    set(ip, host1, host2)
  }
  xpmSwitchHost()
  console.log('switch host suc')

  shell.cd(xpmPath)
  shell.exec(`pwd`)
  shell.exec(`sudo kill -9 80`)
  shell.exec(`sudo xpm local ${projectName}`)
}

function http_server_80 () {
  shell.exec(`sudo kill -9 80`)
  shell.exec(`sudo http-server -p 80`)
}

function compileCss () {

}

function test1 () {
  console.log('test1')
}

function test2 () {
  console.log('test2')
}

// 生成项目列表,后续生成项目名快捷方式
function traverseProjects () {
  var stream = fsReaddir(xpmPath)
  .on('error', function(err) {
    console.log('error:', err);
  }).on('folder', function(folder) {
    console.log('folder:', folder);
  })
}
traverseProjects()

const model = {
  D: function() {

  }


}

var projectName = process.argv[2]
var action = process.argv[3]
model[action]()
switch(action) {
  case '-D':
    xpmDev()
    break
  case '-P':
    xpmPublish()
    break
  case '-L':
    xpmLocal()
    break
  case '-S':
    http_server_80()
    break
  case '-H':
    xpmSwitchHost()
    break
  case '-C': 
    compileCss()
    break
  case '-test1':
    test1()
    break
  case '-test2':
    test2()
    break
}





